# coding=utf-8
from unittest import TestCase
import os
import tempfile

from earthdiagnostics.earthdiags import EarthDiags


class TestEarthDiags(TestCase):

    def setUp(self):
        self.earthdiags = EarthDiags()

    def test_clean(self):
        self.earthdiags.config.scratch_dir = tempfile.mkdtemp()
        os.makedirs(os.path.join(self.earthdiags.config.scratch_dir, 'extra_folder'))

        self.assertTrue(os.path.isdir(self.earthdiags.config.scratch_dir))
        self.earthdiags.clean()
        self.assertFalse(os.path.isdir(self.earthdiags.config.scratch_dir))

    def test_clean_link(self):
        temp_folder = tempfile.mkdtemp()
        scratch_dir = tempfile.mktemp()
        os.symlink(temp_folder, scratch_dir)
        os.makedirs(os.path.join(temp_folder, 'extra_folder'))
        self.earthdiags.config.scratch_dir = scratch_dir

        self.assertTrue(os.path.islink(self.earthdiags.config.scratch_dir))
        self.assertTrue(os.path.isdir(temp_folder))
        self.earthdiags.clean()
        self.assertFalse(os.path.islink(self.earthdiags.config.scratch_dir))
        self.assertFalse(os.path.isdir(temp_folder))
